#region StandardUsing
using System;
using QPlatform.CoreBase;
using QPlatform.HMIProject;
using UAManagedCore;
using OpcUa = UAManagedCore.OpcUa;
using QPlatform.NetLogic;
using QPlatform.UI;
using QPlatform.OPCUAServer;
#endregion

public class LoginForm1Logic1 : QPlatform.NetLogic.BaseNetLogic
{
    public override void Start()
    {
        // Insert code to be executed when the user-defined logic is started
    }

    public override void Stop()
    {
        // Insert code to be executed when the user-defined logic is stopped
    }
    [ExportMethod]
    public void Login(string username, string password)
    {
        if (!PerformLogin(username, password))
        {
            // Set incorrect login message
            var messageVariable = logicObject.GetVariable("Message");
            messageVariable.Value = "Incorrect login";
            return;
        }

        // Check the correct type of PanelLoader
        PanelLoader panelLoader = (PanelLoader) Owner.Owner;
        if (panelLoader == null)
        {
            Log.Error(panelLoader + " is not a PanelLoader");
            return;
        }

        // Retrieve Panel variable
        var panelVariable =  (NodeId) logicObject.GetVariable("Panel").Value;

        if (panelVariable == NodeId.Empty)
        {
            Log.Error("Panel variable is empty");
            return;
        }

        // Perform ChangePanel
        panelLoader.ChangePanel(panelVariable, NodeId.Empty);
    }

    private bool PerformLogin(string username, string password)
    {
        var coreCommandsNodeId = QPlatform.CoreBase.Objects.CoreCommands;
        var coreCommandsObject = logicObject.Context.GetObject(coreCommandsNodeId);
        object[] outputArgs;
        coreCommandsObject.ExecuteMethod("ChangeUser", new object[] { username, password }, out outputArgs);
        return (bool)outputArgs[0];
    }

}
